/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006      by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: prc_config.c 1157 2008-06-26 03:10:08Z ertl-yutaka $
 */

/*
 *		ץå¸⥸塼M32Rѡ
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include "target_syssvc.h"

/*
 *  CPUåե饰¸Τѿ
 */
volatile bool_t		lock_flag;		/* CPUåե饰ͤݻѿ */
volatile uint8_t	saved_iipm;		/* ͥ٥ޥ¸ѿ */

/*
 *  ץå¸ν
 */
void
prc_initialize(void)
{
	/*
     *  CPUåե饰¸Τѿν
     */
    lock_flag = true;
    saved_iipm = IIPM_ENAALL;
}

/*
 *  ץå¸νλ
 */
void
prc_terminate(void)
{
}

/*
 *  ׵饤°
 *
 *  ASPͥǤѤꤷơѥ᡼顼ϥǥ
 *  Ƥ롥FI4ͥѤˤϡ顼֤褦ˤ
 *  Ǥ
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
	uint32_t ctlr;
	uint8_t new_atrpri = 0x00;

    assert(VALID_INTNO_CFGINT(intno));
    assert(-7 <= intpri && intpri <= TMAX_INTPRI);
		
	ctlr = IRC_CTL_BASE + intno * 4;

    /* 
     *  öߤػߤ
     */    
    (void)x_disable_int(intno);

    /*
     *  ٥ȥꥬ/åȥꥬ
     */

	if((intatr & TA_POSEDGE) != 0U) {
		/*
		 *  ݥƥ֥å
		 */
		new_atrpri = IRC_POSEDGE;		
	}else if((intatr & TA_LOWLEVEL) != 0U){
		/*
		 *  ٥ȥꥬ
		 */
		new_atrpri = IRC_LOWLEVEL;
	}else if((intatr & TA_HIGHLEVEL) != 0) {
		/*
		 *  ϥ٥ȥꥬ
		 */
		new_atrpri = IRC_HICHLEVEL;
	}else {
		/*
		 *  ͥƥ֥å
		 */
		new_atrpri = IRC_NEGEDGE;
	}
			 
	/*
	 *  ͥ٤
	 */
	new_atrpri |= INT_IPM(intpri);
	sil_wrb_mem((void*)(ctlr+3), new_atrpri);        

    /*
     *  ׵ޥ(ɬפʾ)
     *  Ʊ˳ͥ٤⥻åȤ
     */
    if ((intatr & TA_ENAINT) != 0U) {
        (void) x_enable_int(intno);
    }    
}

#ifdef SUPPORT_XLOG_SYS
/*
 *  CPU㳰ȯΥ
 *
 *  CPU㳰ϥɥ椫顤CPU㳰ݥ󥿡p_excinfˤȤ
 *  ƸƤӽФȤǡCPU㳰ȯ򥷥ƥ˽Ϥ롥
 */
void
xlog_sys(void *p_excinf)
{
	char	*excsp = (char *) p_excinf;
	syslog_0(LOG_ERROR, "CPU Exception Information:");
}
#endif /* SUPPORT_XLOG_SYS */

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 *  ̤Ͽγߤȯ˸ƤӽФ
 */
void
default_int_handler(void *p_excinf)
{
    syslog(LOG_EMERG, "Unregistered Interrupt occurs.");
    while(1);
}
#endif /* OMIT_DEFAULT_INT_HANDLER */

#ifndef OMIT_DEFAULT_EXC_HANDLER
/*
 * ̤㳰äν
 */
void
default_exc_handler(void *p_excinf){
    syslog(LOG_EMERG, "Unregistered Exception occurs.");
    while(1);
}
#endif /* OMIT_DEFAULT_EXC_HANDLER */

